﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using DuckEmulator.HabboHotel.Outside.Rooms;

namespace DuckEmulator.GUI.Actions.Handle
{
    partial class Rooms : Form
    {
        private Dictionary<uint, string> RoomData;

        private uint Selected = 0;

        internal Rooms()
        {
            InitializeComponent();

            if (!DuckEnvironment.Started)
            {
                button1.Enabled = false;
            }
            else
            {
                LoadRooms();
            }
        }

        internal void LoadRooms()
        {
            RoomData = new Dictionary<uint, string>();
            RoomList.Items.Clear();

            DuckEnvironment.RoomManager.AliveRooms.Values.ToList().ForEach(AddRoom);
        }

        internal void AddRoom(Room Room)
        {
            RoomData.Add(Room.Id, Room.Name);

            foreach (string Name in RoomData.Values.ToList())
            {
                RoomList.Items.Add(Name);
            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            LoadRooms();
        }

        private uint GetId(string RoomName)
        {
            foreach (KeyValuePair<uint, string> kvp in RoomData)
            {
                if (kvp.Value == RoomName) return kvp.Key;
            }

            return 0;
        }

        private void RoomList_SelectedIndexChanged(object sender, EventArgs e)
        {
            uint Id = GetId(RoomList.SelectedItem.ToString()); if (Id == 0) { Selected = 0; return; }
            Selected = Id;

            room_id.Text = Id.ToString();
            room_name.Text = RoomList.SelectedItem.ToString();

           // if (room_name.Text != "") UnloadRoom.Enabled = true;
           // else UnloadRoom.Enabled = false;
        }

        private void button2_Click(object sender, EventArgs e)
        {
            DuckEnvironment.RoomManager.UnloadRoom(Selected);

            MessageBox.Show("Unloaded room.");
        }
    }
}
