﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;

namespace DuckEmulator.HabboHotel.Inside.Core
{
    class ConfigManager
    {
        internal Dictionary<string, string> KeyVals;
        internal readonly string Path = "settings.ini";

        internal ConfigManager()
        {
            LoadData();
        }

        internal Boolean CheckFile
        {
            get { return File.Exists(Path); }
        }

        internal void LoadData()
        {
            KeyVals = new Dictionary<string, string>();

            if (!CheckFile)
            {
                return;
            }

            var Lines = File.ReadAllLines(Path);

            foreach (string Line in Lines.ToList())
            {
                if (Line.Contains('='))
                {
                    var keyval = Line.Split('=');

                    KeyVals.Add(keyval[0], keyval[1]);
                }
            }
        }
    }
}
