﻿using System;
using DuckEmulator.HabboHotel.Inside.Storage.MySql.Database.Interfaces;
using DuckEmulator.HabboHotel.Inside.Storage.MySql.Database.Exceptions;

namespace DuckEmulator.HabboHotel.Inside.Storage.MySql.Database.SessionDetails
{
    internal class NormalQueryReactor : QueryAdapter, IQueryAdapter, IRegularQueryAdapter, IDisposable
    {
        internal NormalQueryReactor(DatabaseClient client) : base(client)
        {
            command = client.getNewCommand();
        }

        #region IQueryAdapter Members

        public void Dispose()
        {
            command.Dispose();
            client.reportDone();
        }

        public void doCommit()
        {
            new TransactionException("Can't use rollback on a non-transactional Query reactor");
        }

        public void doRollBack()
        {
            new TransactionException("Can't use rollback on a non-transactional Query reactor");
        }

        #endregion

        internal bool getAutoCommit()
        {
            return true;
        }
    }
}