﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace DuckEmulator.HabboHotel.Outside.Items
{
    class Item
    {
        internal uint Id;
        internal string SpriteName;
        internal string Type;
        internal int Width;
        internal int Length;
        internal double Height;
        internal Boolean CanStack;
        internal Boolean CanSit;
        internal Boolean CanWalk;
        internal uint SpriteId;
        internal Boolean CanRecycle;
        internal Boolean CanTrade;
        internal Boolean CanSell;
        internal Boolean CanSend;
        internal Boolean CanStackInventory;
        internal string InteractionType;
        internal int InteractionModesCount;
        internal List<int> VendingIds;

        internal Item(uint Id,
         string SpriteName,
         string Type,
         int Width,
         int Length,
         double Height,
         Boolean CanStack,
         Boolean CanSit,
         Boolean CanWalk,
         uint SpriteId,
         Boolean CanRecycle,
         Boolean CanTrade,
         Boolean CanSell,
         Boolean CanSend,
         Boolean CanStackInventory,
         string InteractionType,
         int InteractionModesCount,
         List<string> VendingIds)
        {
            this.Id = Id;
            this.SpriteName = SpriteName;
            this.Type = Type;
            this.Width = Width;
            this.Length = Length;
            this.Height = Height;
            this.CanStack = CanStack;
            this.CanSit = CanSit;
            this.CanWalk = CanWalk;
            this.SpriteId = SpriteId;
            this.CanRecycle = CanRecycle;
            this.CanTrade = CanTrade;
            this.CanSell = CanSell;
            this.CanSend = CanSend;
            this.CanStackInventory = CanStackInventory;
            this.InteractionType = InteractionType;
            this.InteractionModesCount = InteractionModesCount;

            this.VendingIds = new List<int>();

            foreach (string Vid in VendingIds)
            {
                int i;
                if (int.TryParse(Vid, out i))
                {
                    this.VendingIds.Add(i);
                }
            }
        }
    }
}
