﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using DuckEmulator.HabboHotel.Outside.Furniture;
using DuckEmulator.HabboHotel.Outside.Rooms;

namespace DuckEmulator.HabboHotel.Outside.Items.Triggers
{
    class DefaultTrigger : TriggerStruct
    {
        internal override void FurniPlaced(Furni Furni)
        {
            Furni.ExtraData = "0";
            Furni.SerializeUpdates();
        }

        internal override void FurniTaken(Furni Furni)
        {
            Furni.ExtraData = "0";
        }

        internal override void FurniTriggered(int Request, Furni Furni, RoomUser User)
        {
            if (!User.GetRoom().RoomEngine.HasRights(User.GetClient().GetHabbo(), true)) return;
            int State;

            if (!int.TryParse(Furni.ExtraData, out State))
            { State = 0; }

            State++;

            if (State >= Furni.GetBaseItem().InteractionModesCount) State = 0;

            Furni.ExtraData = State + "";
            Furni.UpdateStatus();
        }
    }
}
