﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DuckEmulator.HabboHotel.Outside.Furniture;
using DuckEmulator.HabboHotel.Outside.Clients;
using DuckEmulator.Security;
using DuckEmulator.HabboHotel.Outside.Messages.Types;

namespace DuckEmulator.HabboHotel.Outside.Rooms.Trade
{
    class TradeUser
    {
        internal readonly uint HabboId;
        internal readonly uint TradeId;
        internal UserType TradeType;

        internal Boolean HasAccepted;
        internal SecurityList<Furni> TradedItems;

        internal TradeUser(uint HabboId, uint TradeId, UserType TradeType)
        {
            this.HabboId = HabboId;
            this.TradeId = TradeId;
            this.TradeType = TradeType;

            this.TradedItems = new SecurityList<Furni>();
        }

        internal void SendResponse(ServerMessage Message)
        {
            if (GetClient() == null || Message == null) return;

            GetClient().GetConnection().SendResponse(Message);
        }

        internal Client GetClient()
        {
            return DuckEnvironment.ClientManager.GetClientByHabboId(HabboId);
        }

        internal Trade GetTrade()
        {
            return DuckEnvironment.TradeManager.GetTradeById(TradeId);
        }
    }
}
