﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows.Forms;
using System.IO;
using DuckEmulator.Security;
using System.Diagnostics;

namespace DuckEmulator
{
    static class Program
    {
        [STAThread]
        static void Main()
        {
            AppDomain currentDomain = AppDomain.CurrentDomain;
            currentDomain.UnhandledException += new UnhandledExceptionEventHandler(MyHandler);

            try
            {
                DuckEnvironment.Start();
            }
            catch (Exception e)
            {
                DuckEnvironment.WriteLine(e.ToString(),ConsoleColor.Red);
                Console.ReadKey();
            }

            Console.ReadKey(true);
        }

        static void MyHandler(object sender, UnhandledExceptionEventArgs args)
        {
            Exception e = (Exception)args.ExceptionObject;

            StreamWriter log;

            if (!File.Exists("log.errors"))
            {
                log = new StreamWriter("log.errors");
            }
            else
            {
                log = File.AppendText("log.errors");
            }

            // Write to the file:
            log.WriteLine(Environment.NewLine);
            log.WriteLine(DateTime.Now + "=" + e.ToString());

            // Close the stream:
            log.Close();

            DuckEnvironment.WriteLine(e.ToString(), ConsoleColor.Red);

            Console.ReadKey(true);
        }
    }
}
